/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.42 by adcroft, Thu Nov 20 18:29:07 2003 UTC revision 1.73 by edhill, Tue Mar 16 18:20:34 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
84        PLATFORM=$tmp3
85      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
86      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
87            
# Line 93  find_possible_configs()  { Line 101  find_possible_configs()  {
101          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
102      fi      fi
103    
104      # makedepend is not always available      #  The "original" makedepend is part of the Imake system that is
105        #  most often distributed with XFree86 or with an XFree86 source
106        #  package.  As a result, many machines (eg. generic Linux) do not
107        #  have a system-default "makedepend" available.  For those
108        #  systems, we have two fall-back options:
109        #
110        #    1) a makedepend implementation shipped with the cyrus-imapd
111        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
112        #
113        #    2) a known-buggy xmakedpend shell script
114        #
115        #  So the choices are, in order:
116        #
117        #    1) use the user-specified program
118        #    2) use a system-wide default
119        #    3) locally build and use the cyrus implementation
120        #    4) fall back to the buggy local xmakedpend script
121        #
122      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
123        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
124        RETVAL=$?        RETVAL=$?
125        if test "x${RETVAL}" = x1 ; then        if test ! "x${RETVAL}" = x0 ; then
126           echo "    makedepend was not found. Using xmakedpend instead."           echo "    a system-default makedepend was not found."
127           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'  
128             #  Try to build the cyrus impl
129             rm -f ./genmake_cy_md
130             (
131                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
132                     &&  ./configure > /dev/null 2>&1  \
133                     &&  make > /dev/null 2>&1  \
134                     &&  ./makedepend ifparser.c > /dev/null 2>&1  \
135                     &&  echo "true"
136             ) > ./genmake_cy_md
137             grep true ./genmake_cy_md > /dev/null 2>&1
138             RETVAL=$?
139             if test "x$RETVAL" = x0 ; then
140                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
141             else
142                 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
143             fi
144             rm -f ./genmake_cy_md
145        fi        fi
146      fi      fi
147    
# Line 138  EOF Line 180  EOF
180          echo "   "$p_FC          echo "   "$p_FC
181          if test "x$FC" = x ; then          if test "x$FC" = x ; then
182              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
183                echo "  Setting FORTRAN compiler to: "$FC
184          fi          fi
185      fi      fi
186    
187      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
188          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
189          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
190              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
191              echo "  The options file:  $p_OF"          fi
192              echo "    appears to match so we'll use it."      fi
193              break  #    echo "  The options file:  $p_OF"
194          fi  #    echo "    appears to match so we'll use it."
195      done  #   for i in $p_FC ; do
196    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
197    #if test -r $p_OF ; then
198    #    OPTFILE=$p_OF
199    #    echo "  The options file:  $p_OF"
200    #    echo "    appears to match so we'll use it."
201    #    break
202    #fi
203    #   done
204      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
205          cat 1>&2 <<EOF          cat 1>&2 <<EOF
206    
# Line 208  get_pdepend_list()  { Line 259  get_pdepend_list()  {
259      . ./.pd_tmp      . ./.pd_tmp
260      rm -f ./.pd_tmp      rm -f ./.pd_tmp
261    
262      echo -n "PNAME = "${}      printf "PNAME = "${}
263  }  }
264    
265    
# Line 246  Usage: "$0" [OPTIONS] Line 297  Usage: "$0" [OPTIONS]
297        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
298            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
299    
300        -makedepend NAME | -md NAME
301          --makedepend=NAME | -md=NAME
302              Use "NAME" for the MAKEDEPEND program.
303    
304      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
305        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
306            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 287  Usage: "$0" [OPTIONS] Line 342  Usage: "$0" [OPTIONS]
342            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
343            is being used.            is being used.
344    
345        -mpi | --mpi
346              Include MPI header files and link to MPI libraries
347        -mpi=PATH | --mpi=PATH
348              Include MPI header files and link to MPI libraries using MPI_ROOT
349              set to PATH. i.e. Include files from $PATH/include, link to libraries
350              from $PATH/lib and use binaries from $PATH/bin.
351    
352        -bash NAME
353              Explicitly specify the Bourne or BASH shell to use
354    
355    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
356    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
357    
# Line 324  WARNING: Please contact <MITgcm-support@ Line 389  WARNING: Please contact <MITgcm-support@
389  EOF  EOF
390          return 1          return 1
391      fi      fi
392      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
393      RETVAL=$?      RETVAL=$?
394      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
395          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 354  WARNING: Please contact <MITgcm-support@ Line 419  WARNING: Please contact <MITgcm-support@
419  EOF  EOF
420          return 1          return 1
421      fi      fi
422      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
423      RETVAL=$?      RETVAL=$?
424      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
425          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 430  EOF Line 495  EOF
495  }  }
496    
497    
498    check_netcdf_libs()  {
499        cat <<EOF > genmake_tnc.F
500          program fgennc
501    #include "netcdf.inc"
502          integer iret, ncid, xid
503          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
504          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
505          iret = nf_def_dim(ncid, 'X', 11, xid)
506          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
507          iret = nf_close(ncid)
508          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
509          end
510    EOF
511        $CPP genmake_tnc.F > genmake_tnc.f  \
512            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
513        RET_COMPILE=$?
514        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
515        RETVAL=$?
516        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
517            HAVE_NETCDF=t
518        else
519            # try again with "-lnetcdf" added to the libs
520            $CPP genmake_tnc.F > genmake_tnc.f  \
521                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
522                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
523            RET_COMPILE=$?
524            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
525            RETVAL=$?
526            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
527                LIBS="$LIBS -lnetcdf"
528                HAVE_NETCDF=t
529            else
530                cat genmake_tnc.log >> genmake_warnings
531            fi
532        fi
533        rm -f genmake_tnc*
534    }
535    
536    
537    
538    ###############################################################################
539    #   Sequential part of script starts here
540    ###############################################################################
541    
542  #  Set defaults here  #  Set defaults here
543  COMMANDL="$0 $@"  COMMANDL="$0 $@"
544    
# Line 438  LN= Line 547  LN=
547  S64=  S64=
548  KPP=  KPP=
549  FC=  FC=
550    CPP=
551  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
552  DEFINES=  DEFINES=
553  PACKAGES=  PACKAGES=
554  ENABLE=  ENABLE=
# Line 456  FOPTIM= Line 565  FOPTIM=
565  CFLAGS=  CFLAGS=
566  KFLAGS1=  KFLAGS1=
567  KFLAGS2=  KFLAGS2=
568    #LDADD=
569  LIBS=  LIBS=
570  KPPFILES=  KPPFILES=
571  NOOPTFILES=  NOOPTFILES=
572  NOOPTFLAGS=  NOOPTFLAGS=
573    MPI=
574    MPIPATH=
575    
576  # DEFINES checked by test compilation  # DEFINES checked by test compilation
577  HAVE_SYSTEM=  HAVE_SYSTEM=
578  HAVE_FDATE=  HAVE_FDATE=
579  FC_NAMEMANGLE=  FC_NAMEMANGLE=
580  HAVE_CLOC=  HAVE_CLOC=
581    HAVE_NETCDF=
582    
583  MODS=  MODS=
584  TOOLSDIR=  TOOLSDIR=
585  SOURCEDIRS=  SOURCEDIRS=
586  INCLUDEDIRS=  INCLUDEDIRS=
587  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
588    
589    G2ARGS=
590    BASH=
591  PWD=`pwd`  PWD=`pwd`
592  MAKE=make  MAKE=make
593  AWK=awk  AWK=awk
# Line 505  TAMC_EXTRA= Line 620  TAMC_EXTRA=
620    
621  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
622  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
623  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
624    
625  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
626  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 541  for i in . $MODS ; do Line 656  for i in . $MODS ; do
656          break          break
657      fi      fi
658  done  done
659  echo -n "  getting local config information:  "  printf "  getting local config information:  "
660  if test -e $gm_local ; then  if test -e $gm_local ; then
661      echo "using $gm_local"      echo "using $gm_local"
662      . $gm_local      . $gm_local
# Line 565  fi Line 680  fi
680  ac_prev=  ac_prev=
681  for ac_option ; do  for ac_option ; do
682    
683        G2ARGS="$G2ARGS \"$ac_option\""
684    
685      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
686      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
687          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 586  for ac_option ; do Line 703  for ac_option ; do
703          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
704              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
705                    
706          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
707              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
708          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
709              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 606  for ac_option ; do Line 723  for ac_option ; do
723          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
724              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
725                    
726            -bash | --bash)
727                ac_prev=BASH ;;
728            -bash=* | --bash=*)
729                BASH=$ac_optarg ;;
730            
731            -makedepend | --makedepend | -md | --md)
732                ac_prev=MAKEDEPEND ;;
733            -makedepend=* | --makedepend=* | -md=* | --md=*)
734                MAKEDEPEND=$ac_optarg ;;
735            
736          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
737              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
738          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 657  for ac_option ; do Line 784  for ac_option ; do
784              IEEE=true ;;              IEEE=true ;;
785          -noieee | --noieee)          -noieee | --noieee)
786              IEEE= ;;              IEEE= ;;
787    
788            -mpi | --mpi)
789                MPI=true ;;
790            -mpi=* | --mpi=*)
791                MPIPATH=$ac_optarg
792                MPI=true ;;
793                    
794  #       -jam | --jam)  #       -jam | --jam)
795  #           JAM=1 ;;  #           JAM=1 ;;
# Line 709  if test "x${ROOTDIR}" = x ; then Line 842  if test "x${ROOTDIR}" = x ; then
842          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
843              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
844                  ROOTDIR=$d                  ROOTDIR=$d
845                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
846                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
847                  break                  break
848              fi              fi
# Line 743  if test "x$OPTFILE" != xNONE ; then Line 876  if test "x$OPTFILE" != xNONE ; then
876          . "$OPTFILE"          . "$OPTFILE"
877          RETVAL=$?          RETVAL=$?
878          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
879              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
880              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
881              exit 1              exit 1
882          fi          fi
# Line 770  if test "x${AD_OPTFILE}" != xNONE ; then Line 903  if test "x${AD_OPTFILE}" != xNONE ; then
903          . "$AD_OPTFILE"          . "$AD_OPTFILE"
904          RETVAL=$?          RETVAL=$?
905          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
906              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
907              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
908              exit 1              exit 1
909          fi          fi
# Line 785  fi Line 918  fi
918    
919  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
920  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
921    if test ! "x$BASH" = x ; then
922        # add a trailing space so that it works within the Makefile syntax (see below)
923        BASH="$BASH "
924    fi
925  if test "x$FC" = x ; then  if test "x$FC" = x ; then
926      cat <<EOF 1>&2      cat <<EOF 1>&2
927    
# Line 798  fi Line 935  fi
935  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
936      LINK=$FC      LINK=$FC
937  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
938  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
939      MAKE="make"      MAKE="make"
940  fi  fi
941    if test "x$CPP" = x ; then
942        CPP=cpp
943    fi
944    #EH3 === UGLY ===
945    #  The following an ugly little hack to check for $CPP in /lib/ and it
946    #  should eventually be replaced with a more general function that
947    #  searches a combo of the user's path and a list of "usual suspects"
948    #  to find the correct location for binaries such as $CPP.
949    for i in " " "/lib/" ; do
950        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
951    done
952    #EH3 === UGLY ===
953  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
954  RETVAL=$?  RETVAL=$?
955  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 840  EOF Line 986  EOF
986  fi  fi
987  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
988    
989    if test ! "x$MPI" = x ; then
990          echo "  Turning on MPI cpp macros"
991          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
992    fi
993    
994  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
995  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
996  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
997        program hello        program hello
998        call system('echo hi')        call system('echo hi')
# Line 860  else Line 1010  else
1010  fi  fi
1011  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1012    
1013  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1014  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1015        program hello        program hello
1016        CHARACTER(128) string        CHARACTER(128) string
# Line 881  else Line 1031  else
1031  fi  fi
1032  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1033    
1034  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1035  check_HAVE_CLOC  check_HAVE_CLOC
1036  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1037      echo "yes"      echo "yes"
1038  else  else
1039      echo "no"      echo "no"
1040  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
1041  rm -f genmake_t*  rm -f genmake_t*
1042    
1043    printf "  Can we create NetCDF-enabled binaries...  "
1044    check_netcdf_libs
1045    if test "x$HAVE_NETCDF" != x ; then
1046        echo "yes"
1047    else
1048        echo "no"
1049    fi
1050    
1051    
1052  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1053  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1054  for d in $MODS ; do  for d in $MODS ; do
1055      if test ! -d $d ; then      if test ! -d $d ; then
1056          echo          echo
1057          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1058          exit 1          exit 1
1059      else      else
1060          echo -n " $d"          printf " $d"
1061          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1062          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1063      fi      fi
# Line 935  if test "x${TOOLSDIR}" = x ; then Line 1087  if test "x${TOOLSDIR}" = x ; then
1087      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1088  fi  fi
1089  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1090      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1091      exit 1      exit 1
1092  fi  fi
1093  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1094      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1095  fi  fi
1096    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1097    
1098  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1099    
# Line 955  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1108  if test -r $ROOTDIR"/eesupp/src/Makefile
1108          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1109      else      else
1110          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1111          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1112          exit 1          exit 1
1113      fi      fi
1114  fi  fi
1115    
1116    #same for exch2
1117    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1118        echo "  Making source files in exch2 from  templates"
1119        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1120        RETVAL=$?
1121        if test "x${RETVAL}" = x0 ; then
1122            rm -f make_exch2.errors
1123        else
1124            echo "Error: problem encountered while building source files in exch2:"
1125            cat make_exch2.errors 1>&2
1126            exit 1
1127        fi
1128    fi
1129    
1130  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1131  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1132      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1015  else Line 1182  else
1182          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1183          RETVAL=$?          RETVAL=$?
1184          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1185              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1186              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1187              exit 1              exit 1
1188          fi          fi
# Line 1143  for i in $PACKAGES ; do Line 1310  for i in $PACKAGES ; do
1310      fi      fi
1311  done  done
1312    
1313    #  Build MNC templates and check for ability to build and use NetCDF
1314    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1315    RETVAL=$?
1316    if test "x$RETVAL" = x0 ; then
1317        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1318        RETVAL=$?
1319        if test "x${RETVAL}" = x0 ; then
1320            rm -f make_mnc.errors
1321        else
1322            echo "Error: problem encountered while building source files in pkg/mnc:"
1323            cat make_mnc.errors 1>&2
1324            exit 1
1325        fi
1326        if test "x$HAVE_NETCDF" != xt ; then
1327            cat <<EOF
1328    
1329  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1330  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1331    
1332  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1333      2) the LIBS variable (within the 'optfile") specifies the correct
1334           NetCDF library to link against.
1335      
1336  EOF  EOF
1337        fi
1338    fi
1339    
1340    # Create a list of #define and #undef to enable/disable packages
1341    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1342  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1343  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1344  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1345  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1346  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1347  all_pack=  all_pack=
1348    DISABLED_PACKAGES=
1349  for n in $names ; do  for n in $names ; do
1350      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1351          has_pack="f"          has_pack="f"
# Line 1175  for n in $names ; do Line 1357  for n in $names ; do
1357          done          done
1358          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1359              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1360              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1361          fi          fi
1362      fi      fi
1363  done  done
1364  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1365  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1366      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1367      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1368  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1369    
1370  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1371      case $i in      case $i in
1372          aim_v23)          aim_v23)
1373              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1374              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1375              ;;              ;;
1376      esac      esac
1377  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1378    
1379  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1380    
1381  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1382  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1383  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1384      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1385  fi  fi
1386  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1387      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1388      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1389          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1390          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1391          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1392      else              exit 1
1393          SOURCEDIRS="$SOURCEDIRS $adr"          else
1394      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1395      adr="$ROOTDIR/$d/inc"          fi
1396      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1397          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1398          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1399          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1400      else              exit 1
1401          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1402      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1403  done          fi
1404        done
1405    fi
1406    
1407  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1408  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1409  CPP_OPTIONS=  CPP_OPTIONS=
1410    CPP_EEOPTIONS=
1411  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1412    names=`ls -1 "$ROOTDIR/pkg"`
1413  for i in $spaths ; do  for i in $spaths ; do
1414      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1415      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1416          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1417          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1418          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1419            for n in $names ; do
1420                test_for_package_in_cpp_options $CPP_OPTIONS $n
1421            done
1422        fi
1423        try="$i/CPP_EEOPTIONS.h"
1424        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1425            echo "    found CPP_EEOPTIONS=\"$try\""
1426            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1427    #**** not yet enabled ****
1428    #        test_for_mpi_in_cpp_eeoptions $try
1429    #**** not yet enabled ****
1430            CPP_EEOPTIONS="$try"
1431      fi      fi
1432  done  done
1433  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1434      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1435      exit 1      exit 1
1436  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1437    
1438  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1439  #  compiler.  #  compiler.
# Line 1278  for i in $SOURCEDIRS ; do Line 1448  for i in $SOURCEDIRS ; do
1448      done      done
1449  done  done
1450    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1451    
1452  echo  echo
1453  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1306  rm -rf .links.tmp Line 1465  rm -rf .links.tmp
1465  mkdir .links.tmp  mkdir .links.tmp
1466  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1467  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1468  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1469  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1470  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1471  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1472  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1473  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1474  for d in $alldirs ; do  for d in $alldirs ; do
1475      deplist=      deplist=
# Line 1319  for d in $alldirs ; do Line 1478  for d in $alldirs ; do
1478      for sf in $sfiles ; do      for sf in $sfiles ; do
1479          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1480              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1481                    case $d/$sf in
1482                      ./$PACKAGES_DOT_H)
1483                            ;;
1484                      ./AD_CONFIG.h)
1485                            ;;
1486                      ./FC_NAMEMANGLE.h)
1487                            ;;
1488                      *)
1489                            touch .links.tmp/$sf
1490                            deplist="$deplist $sf"
1491                            ;;
1492                    esac
1493                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1494                  case $extn in                  case $extn in
1495                      F)                      F)
1496                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1497                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1498                          ;;                          ;;
1499                      F90)                      F90)
1500                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1501                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1502                          ;;                          ;;
1503                      c)                      c)
1504                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1505                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1506                          ;;                          ;;
1507                      h)                      h)
1508                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1509                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1510                          ;;                          ;;
1511                      flow)                      flow)
1512                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1513                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1514                          ;;                          ;;
1515                  esac                  esac
1516              fi              fi
# Line 1370  echo "#    $MACHINE" >> $MAKEFILE Line 1539  echo "#    $MACHINE" >> $MAKEFILE
1539  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1540  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1541  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1542  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1543  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1544  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1545    
# Line 1379  EXE_FTL=$EXECUTABLE"_ftl" Line 1548  EXE_FTL=$EXECUTABLE"_ftl"
1548  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1549    
1550  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1551    #
1552    # OPTFILE="$OPTFILE"
1553  #  #
1554  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1555  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1412  EXE_AD      = ${EXE_AD} Line 1583  EXE_AD      = ${EXE_AD}
1583  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1584  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1585    
1586    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1587    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1588    
1589    # These files are created by Makefile
1590    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1591    
1592  EOF  EOF
1593    
1594  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1430  FC = ${FC} Line 1607  FC = ${FC}
1607  # Fortran compiler  # Fortran compiler
1608  F90C = ${F90C}  F90C = ${F90C}
1609  # Link editor  # Link editor
1610  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1611    
1612  # Defines for CPP  # Defines for CPP
1613  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1476  cat >>$MAKEFILE <<EOF Line 1653  cat >>$MAKEFILE <<EOF
1653  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1654    
1655  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1656  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1657            @echo Creating \$@ ...
1658          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1659  depend:  depend:
1660          @make links          @make links
1661          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1662          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1663            -rm -f makedepend.out
1664    
1665  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1666    
1667  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1668    
# Line 1492  output.txt: \$(EXECUTABLE) Line 1671  output.txt: \$(EXECUTABLE)
1671          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1672    
1673  clean:  clean:
1674          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1675  Clean:  Clean:
1676          @make clean          @make clean
1677          @make cleanlinks          @make cleanlinks
1678          -rm -f Makefile.bak genmake_state genmake_*optfile genmake_warnings make.log          -rm -f \$(SPECIAL_FILES)
1679            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1680  CLEAN:  CLEAN:
1681          @make Clean          @make Clean
1682          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1507  CLEAN: Line 1686  CLEAN:
1686    
1687  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1688  makefile:  makefile:
1689          ${0} $@          $THIS_SCRIPT $G2ARGS
1690  cleanlinks:  cleanlinks:
1691          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1692    
1693    # Special targets ($SPECIAL_FILES) which are create by make
1694    ${PACKAGES_DOT_H}:
1695            @echo Creating \$@ ...
1696            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1697    AD_CONFIG.h:
1698            @echo Creating \$@ ...
1699            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1700    FC_NAMEMANGLE.h:
1701            @echo Creating \$@ ...
1702            echo "$FC_NAMEMANGLE" > \$@
1703    
1704  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1705  .F.f:  .F.f:
1706          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1553  done Line 1743  done
1743    
1744  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1745  echo >> $MAKEFILE  echo >> $MAKEFILE
1746  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1747  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1748  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1749      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1750      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1751  done  done
1752  echo >> $MAKEFILE  echo >> $MAKEFILE
1753  rm -f ad_files  rm -f ad_files
# Line 1570  adtaf: ad_taf_output.f Line 1760  adtaf: ad_taf_output.f
1760  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1761    
1762  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1763            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1764          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1765            -rm -f ad_config.template
1766          @make \$(F77FILES)          @make \$(F77FILES)
1767          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1768          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1769    
1770  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1771          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1772          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1773    
1774  adtafonly:  adtafonly:
1775          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1776          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1777    
1778  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1779          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1780    
1781  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1782          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1783          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1784    
1785  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1786          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1600  ftltaf: ftl_taf_output.f Line 1792  ftltaf: ftl_taf_output.f
1792  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1793    
1794  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1795            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1796          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1797            -rm -f ftl_config.template
1798          @make \$(F77FILES)          @make \$(F77FILES)
1799          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1800          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1801    
1802  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1803          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1804          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1805    
1806  ftltafonly:  ftltafonly:
1807          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1808          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1809    
1810  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1811          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1812    
1813  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1814          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1815          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1816    
1817  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1818          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
# Line 1670  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1864  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1864    
1865  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1866    
1867  #  Write the "template" files for the adjoint builds  # Create special header files
1868  cat >AD_CONFIG.template <<EOF  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1869  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1870  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1871  C    unless you are CERTAIN that you know what you are doing.  else
1872        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1873  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1874  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1875  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1876  EOF      else
1877  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1878  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1879  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1880  C    unless you are CERTAIN that you know what you are doing.  fi
1881    if test ! -f AD_CONFIG.h ; then
1882  #define ALLOW_ADJOINT_RUN      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1883  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1884    
1885    
1886  #  Write the "state" for future records  #  Write the "state" for future records
1887  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1888      echo -n "" > genmake_state      printf "" > genmake_state
1889      for i in $gm_state ; do      for i in $gm_state ; do
1890          t1="t2=\$$i"          t1="t2=\$$i"
1891          eval $t1          eval $t1

Legend:
Removed from v.1.42  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.22